var OpacityPlotter = function() {
    // we have 255 colors
    var coordinateLength = 255;

    // set with respect on plotter height
    var height = 40;

    // array for holding the x coordinates
    var coordinates = Array(coordinateLength);

    // array for holding the y coordinates values elementOf [0, height]
    var linePosition = Array(coordinateLength);

    // array holding the resulting opacities, that will be generated
    // of line position, values elementof [0, 255]
    var opacities = Array(coordinateLength);

    for(counter = 0; counter < coordinateLength; counter++) {
        coordinates[counter] = counter;
        linePosition[counter] = 0;
        opacities[counter] = 255;
    }

    var stage = new Kinetic.Stage({
        container : 'opacity-plot',
        width : coordinateLength,
        height: height
    });

    var layer = new Kinetic.Layer();
    var rect = new Kinetic.Rect({
        x: 0,
        y: 0,
        width: stage.getWidth(),
        height: stage.getHeight(),
        fill: '#cccccc'
    });
    layer.add(rect);

    var spline = new Kinetic.Line({
        points: getResultingPoints(),
        stroke: 'red',
        strokeWidth: 3,
        lineCap: 'round'
    });
    layer.add(spline);

    stage.add(layer);

    stage.on("mousedown", function() {
        processEvent();
    });

    stage.on("mousemove", function(e) {
        if(e.evt.which == 1) {
            processEvent();
        }
    });

    $('#transfer-function-definition').on('controlsShowed', function() {
        populateOpacities();
    });

    $('input#opacity-visible').on('click', function() {
        setToFixedValue(255);
    });

    $('input#opacity-invisible').on('click', function() {
        setToFixedValue(0);
    });

    function setToFixedValue(value) {
        var opacityValue = value;
        var yValue = height - ((value / 255) * height)
        for(counter = 0; counter < opacities.length; counter++) {
            opacities[counter] = opacityValue ;
            linePosition[counter] = yValue;
        }
        populateOpacities();

        spline.setPoints(getResultingPoints());
        layer.draw();
    }

    function populateOpacities() {
        $(document).trigger('opacityChanged', { opacities: opacities.slice() });
    }

    function processEvent() {
        var mousePosition = stage.getPointerPosition();
        calculateOpacities(mousePosition);

        spline.setPoints(getResultingPoints());
        layer.draw();
    }

    function calculateOpacities(mousePosition) {
        // Set area of click to this value
        var xMin = (mousePosition.x - 2 >= 0) ? mousePosition.x - 2 : 0;
        var xMax = (mousePosition.x + 2 <= 255) ? mousePosition.x + 2 : 255;

        var opacityValue = (height - mousePosition.y) / height;
        opacityValue *= 255;

        for(counter = xMin; counter <= xMax; counter++) {
            linePosition[counter] = mousePosition.y;
            opacities[counter] = opacityValue;
        }

        populateOpacities();
    }


    function getResultingPoints() {
        return combineArrays(coordinates, linePosition);
    }

    function combineArrays(array1, array2) {
        return $.map(array1, function(v, i) { return [v, array2[i]]; });
    }
}
