var StepHelper = function() {
    // default is the step 100
    currentStepIndex = 2;
    // steps just defined
    availableSteps = [10, 20, 50, 80, 100, 150, 200];

    return {
        decreaseSteps: function() {
            var currentStepIndex = this.determineCurrentStepIndex();

            if(currentStepIndex > 0) {
                this.updateStepValue(availableSteps[currentStepIndex - 1], true);
            }
        },

        increaseSteps: function() {
            var currentStepIndex = this.determineCurrentStepIndex();

            if(currentStepIndex > -1 && currentStepIndex < availableSteps.length - 1) {
                this.updateStepValue(availableSteps[currentStepIndex + 1], true);
            }
        },

        determineCurrentStepIndex: function() {
            var minDeviation = null,
                minDeviationIndex;

            // first we have to find an appropiate predefined stepValue for input stepvalue
            for(var index = 0; index < availableSteps.length; index++) {
                deviation = Math.abs(steps - availableSteps[index]);
                if(minDeviation == null || deviation < minDeviation) {
                    minDeviation = deviation;
                    minDeviationIndex = index;
                }
            }

            if(minDeviation !== null) {
                return minDeviationIndex;
            } else {
                return -1;
            }
        },

        updateStepValue: function(stepValue, updateInputField) {
            steps = stepValue;
            materialScreen.uniforms.steps.value = steps;
            if(updateInputField) {
                $('#steps').val(stepValue);
            }
        },

        initStepControls: function() {
            var me = this,
                stepsInput = $('#steps'),
                stepsAdjustInput = $('#steps-adjust');

            steps = stepsInput.val();
            stepsInput.change(function() {
                steps = stepsInput.val();
                me.updateStepValue(steps, false);
            });

            adjustSteps = stepsAdjustInput.is(':checked');

            stepsAdjustInput.change(function() {
                adjustSteps = $(this).is(':checked');
                if(adjustSteps) {
                    stepsInput.prop('disabled', true);
                } else {
                    stepsInput.prop('disabled', false);
                }
            });
        }

    };
};
