var VolumeFace = function(orientation, direction) {
    this.orientation = orientation;
    this.direction = direction;
}

VolumeFace.prototype = {
    constructor: VolumeFace,
    orientation: 0,
    direction: 0,

    getAxisOfNaviation: function() {
        var axis = {
                plane: {
                    ver: null,
                    hor: null
                },
                slider: null
            };

        if(this.orientation == VolumeFaceOrientation.XY) {
            axis.plane.ver = new Orientation(Axis.Y);
            axis.plane.hor = new Orientation(Axis.X);
            axis.slider = new Orientation(Axis.Z);
        } else if(this.orientation == VolumeFaceOrientation.YZ) {
            axis.plane.ver = new Orientation(Axis.Z);
            axis.plane.hor = new Orientation(Axis.Y);
            axis.slider = new Orientation(Axis.X);
        } else if(this.orientation == VolumeFaceOrientation.XZ) {
            axis.plane.ver = new Orientation(Axis.Z);
            axis.plane.hor = new Orientation(Axis.X);
            axis.slider = new Orientation(Axis.Y);
        }

        return axis;
    },

    getIdentifier: function() {
        return this.orientation + '-' + this.direction;
    }

};

var VolumeFaceOrientation = {
    XY: 0,
    XZ: 1,
    YZ: 2
}

var VolumeFaceDirection = {
    FRONT: 0,
    BACK: 1
}

function determineVolumeFace(cubeFaceNormal) {
    var orientation, direction;
    if(cubeFaceNormal.x != 0) {
        orientation = VolumeFaceOrientation.YZ;
        direction = determineFaceOrientation(cubeFaceNormal.x);
    } else if(cubeFaceNormal.y != 0) {
        orientation = VolumeFaceOrientation.XZ;
        direction = determineFaceOrientation(cubeFaceNormal.y);
    } else if(cubeFaceNormal.z != 0) {
        orientation = VolumeFaceOrientation.XY;
        direction = determineFaceOrientation(cubeFaceNormal.z);
    }
    return new VolumeFace(orientation, direction);
}

function determineFaceOrientation(normalComp) {
    return normalComp > 0 ? VolumeFaceDirection.FRONT : VolumeFaceDirection.BACK;
}


function isFrontFace(orientation, direction) {
    return orientation == VolumeFaceOrientation.XY
           && direction == VolumeFaceDirection.FRONT;
}

function isBackFace(orientation, direction) {
    return orientation == VolumeFaceOrientation.XY
           && direction == VolumeFaceDirection.BACK;
}

function isLeftFace(orientation, direction) {
    return orientation == VolumeFaceOrientation.YZ
           && direction == VolumeFaceDirection.FRONT;
}

function isRightFace(orientation, direction) {
    return orientation == VolumeFaceOrientation.YZ
           && direction == VolumeFaceDirection.BACK;
}

function isTopFace(orientation, direction) {
    return orientation == VolumeFaceOrientation.XZ
           && direction == VolumeFaceDirection.FRONT;
}

function isBottomFace(orientation, direction) {
    return orientation == VolumeFaceOrientation.XZ
           && direction == VolumeFaceDirection.BACK;
}
