from django import forms
from mongodbforms import DocumentForm
from mongodbforms.fields import MongoCharField

from .models import Volume


class VolumeForm(DocumentForm):
    class Meta:
        document = Volume

    name = MongoCharField(widget=forms.TextInput(attrs={'class': 'special'}))
    path = MongoCharField(widget=forms.TextInput(attrs={'class': 'wide'}))

    def clean(self):
        cleaned_data = super(VolumeForm, self).clean()
        sliceFrom = cleaned_data.get('sliceFrom')
        sliceTo = cleaned_data.get('sliceTo')

        if sliceFrom is not None and sliceTo is None or sliceFrom is None and sliceTo is not None:
            raise forms.ValidationError('Please provice a value for sliceFrom AND sliceTo')

        if sliceFrom is not None and sliceTo is not None:
            if sliceFrom > sliceTo:
                msg = 'sliceFrom has to le than sliceTo'
                self.add_error('sliceFrom', msg)
                self.add_error('sliceTo', msg)
            else:
                cleaned_data['slices'] = sliceTo - sliceFrom

        return cleaned_data
