from mongoengine import Document
from mongoengine import BooleanField, DateTimeField, StringField, IntField, ListField


class SpriteMetaData(Document):
    creationTime = DateTimeField()
    spriteId = StringField()
    format = StringField()
    volumeId = StringField()

    x = IntField()
    y = IntField()
    z = IntField()
    t = IntField()

    depth = IntField()

    jsonInformation = StringField()

    def getfilename(self):
        return str(self.spriteId) + '.jpeg'

    def delete(self):
        return super(SpriteMetaData, self).delete()


class AutomaticProcessing(Document):
    succeeded = IntField()
    errored = IntField()
    processed = IntField()
    finished = BooleanField()
    erroredPaths = ListField(StringField())
