import logging

logger = logging.getLogger(__name__)


def normalize_image(frames, volumeId):
    logger.debug('volId: %s, float frames detected, normalize them' % volumeId)
    collection_min = frames.min()
    collection_max = frames.max()
    logger.debug('volId: %s, imagesmin: %d, imagesmax: %d' % (volumeId, collection_min, collection_max))

    t, z, y, x = frames.shape

    # due to memory problems, we have to trigger it for each frame
    for i in range(t):
        for j in range(z):
            frames[i, j, :, :] = (frames[i, j, :, :] - collection_min) / (collection_max - collection_min)

    logger.debug('volId: %s, after normalization imagesmin: %d, imagesmax: %d' % (volumeId, frames.min(), frames.max()))
