from django.conf.urls import patterns, include, url

from . import views

from .processing import urls as processingurls

# volumes url file

urlpatterns = patterns(
    '',
    url(r'^$', views.index, name='home'),
    url(r'^add/$', views.add, name='add'),
    url(r'^add-list/$', views.addList, name='addList'),
    url(r'^(?P<id>[\da-z]+)/$', views.show),
    url(r'^(?P<id>[\da-z]+)/show/$', views.show, name='show'),
    url(r'^(?P<id>[\da-z]+)/show-status/$', views.showStatus),

    url(r'^(?P<id>[\da-z]+)/render/$', views.render3D, name='render'),
    url(r'^(?P<id>[\da-z]+)/render/(?P<res>[\d]*)/$', views.render3D, name='render-res'),

    url(r'^(?P<id>[\da-z]+)/edit/$', views.edit, name='edit'),
    url(r'^(?P<id>[\da-z]+)/delete/$', views.delete, name='delete'),

    url(r'^(?P<id>[\da-z]+)/texture-info/(?P<size>[\d]+|)/$', views.getTextureInfo, name='texture-info'),
    url(r'^(?P<id>[\da-z]+)/texture-info/(?P<size>[\d]+|)/delete/$', views.deleteTexture, name='delete-texture'),

    url(r'^(?P<id>[\da-z]+)/sprite/(?P<spriteId>[\da-z]+)/$', views.showSprite),

    url(r'^(?P<id>[\da-z]+)/processing/', include(processingurls, namespace='processing')),
)
